﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Controls.Grids;
using Infragistics.Controls.Menus;
using Infragistics.Controls.Grids.Primitives;

namespace XamGridAddContextMenu
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }
        private void XamMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Item 1 clicked!");
        }

        private void XamMenuItem_Click_1(object sender, EventArgs e)
        {
            MessageBox.Show("Item 2 clicked!");
        }

        private void XamMenuItem_Click_2(object sender, EventArgs e)
        {
            MessageBox.Show("Item 3 clicked!");
        }

        private void contextMenu1_Opening(object sender, OpeningEventArgs e)
        {
            Row row = (from x in e.GetClickedElements<CellsPanel>()
                       select x.Row).FirstOrDefault() as Row;
            CellControl cell = e.GetClickedElements<CellControl>().FirstOrDefault();
            if (cell != null && cell.Column is FillerColumn)
                e.Cancel = true;
            // Discard displaying the context menu when not clicking on data rows:
            if (row == null || row.RowType != RowType.DataRow)
            {
                e.Cancel = true;
                
            }
        }
    }
    public class Element
    {
        public Element(string elNumber, string description)
        {
            this.description = description;
            this.elNumber = elNumber;
        }
        private string elNumber;
        public string ElementNumber
        {
            get { return elNumber; }
            set { elNumber = value; }
        }

        private string description;
        public string Description
        {
            get { return description; }
            set { description = value; }
        }

    }
    public class DeviceElements : ObservableCollection<Element>
    {
        public ObservableCollection<Element> GetCollection()
        {
            ObservableCollection<Element> data = new ObservableCollection<Element>
             {
                new Element("dataitem 1","dataitem1description"),
                new Element("dataitem 2","dataitem2description"),
                new Element("dataitem 3","dataitem3description"),
                new Element("dataitem 4","dataitem4description"),
                new Element("dataitem 5","dataitem5description"),
                new Element("dataitem 6","dataitem6description"),
             };
            return data;
        }

        public ObservableCollection<Element> GetSimpleCollection
        {
            get
            {
                return GetCollection();
            }
        }
    }
    //public class XamGridEx : XamGrid
    //{
    //    ContextMenuSettings _contextMenuSettings;

    //    public ContextMenuSettings ContextMenuSettings
    //    {
    //        get
    //        {
    //            if (this._contextMenuSettings == null)
    //            {
    //                this._contextMenuSettings =
    //                new ContextMenuSettings();
    //                this._contextMenuSettings.Grid = this;
    //            }

    //            return this._contextMenuSettings;
    //        }
    //        set
    //        {
    //            if (value != this._contextMenuSettings)
    //            {
    //                this._contextMenuSettings = value;
    //                this._contextMenuSettings.Grid = this;

    //                this.OnPropertyChanged("ContextMenuSettings");
    //            }
    //        }
    //    }

    //    private void OnPropertyChanged(string p)
    //    {
    //        throw new NotImplementedException();
    //    }
    //}

    //public class ContextMenuSettings : SettingsBase
    //{
    //    private ContextMenuManager _contextMenuMgr;

    //    public XamContextMenu ContextMenu { get; set; }

    //    public bool AllowContextMenu
    //    {
    //        get { return (bool)GetValue(AllowContextMenuProperty); }
    //        set { SetValue(AllowContextMenuProperty, value); }
    //    }

    //    public static readonly DependencyProperty AllowContextMenuProperty =
    //        DependencyProperty.Register("AllowContextMenu",
    //            typeof(bool), typeof(ContextMenuSettings),
    //                new PropertyMetadata(false,
    //                    new PropertyChangedCallback(AllowContextMenuChanged)));

    //    private static void AllowContextMenuChanged(DependencyObject obj,
    //        DependencyPropertyChangedEventArgs e)
    //    {
    //        ContextMenuSettings settings = (ContextMenuSettings)obj;
    //        settings.OnAllowContextMenuChanged((bool)e.NewValue);
    //    }

    //    internal virtual void OnAllowContextMenuChanged(bool value)
    //    {
    //    }

    //    /// <summary>  
    //    /// Hack to get around the fact that the SettingsBase.Grid   
    //    /// property setter is internal  
    //    /// </summary>  
    //    public XamGrid Grid
    //    {
    //        get { return base.Grid; }
    //        set { base.Grid = value; }
    //    }
    //    private void AttachContextMenu()
    //    {
    //        if (_contextMenuMgr == null)
    //        {
    //            _contextMenuMgr = new ContextMenuManager();
    //            _contextMenuMgr.ContextMenu = this.ContextMenu;
    //            _contextMenuMgr.ContextMenu.Opening +=
    //               new EventHandler<OpeningEventArgs>(ContextMenuOpening);
    //            _contextMenuMgr.ModifierKeys = ModifierKeys.None;
    //            _contextMenuMgr.OpenMode = OpenMode.RightClick;

    //            ContextMenuService.SetManager(this.Grid, _contextMenuMgr);
    //        }
    //    }

    //    private void DetachContextMenu()
    //    {
    //        if (_contextMenuMgr != null)
    //        {
    //            if (_contextMenuMgr.ContextMenu != null)
    //                _contextMenuMgr.ContextMenu.Opening
    //                    -= new EventHandler<OpeningEventArgs>(ContextMenuOpening);

    //            ContextMenuService.SetManager(this.Grid, null);
    //        }

    //        _contextMenuMgr = null;
    //    }
    //    private void ContextMenuOpening(object sender, OpeningEventArgs e)
    //    {
    //        List<CellControl> elements = e.GetClickedElements<CellControl>();

    //        if (elements.Count == 0) { e.Cancel = true; }
    //    } 


  
    //}


}
